#!/bin/bash
# Funktionen
systemupdate() {
    update=true
    updatetext="Systemupdate: YES \n"
    sysupdate=false
}
  
installprofkt() {
  toinstall=""
  install=`dialog --backtitle "$version" --checklist "Install Software or update System" 0 0 10 \
    Firefox "" off\
    Chromium "" off\
    Libreoffice "" off\
    FlashPlayer "" off\
    Java "" off\
    VLC "" off\
    XBMC "" off\
    Yakuake "" off\
    QGIS "" off\
    Spatzialite-Fedora-only "" off\
    Spatzialite-Gui-Fedora-only "" off\
		QT-Dev "" off\
    Microsoft-Fonts  "" off\
    WINE "" off 3>&1 1>&2 2>&3`
  dialog --clear
  clear
  backup="Apps to install: "$install
  #backup=$backup"$install"
  lss=`echo $install | wc -w`
	echo $install
	for (( i=1; i <= $lss; i++ )) do
      case "$install" in
	    *Firefox*) toinstall=$toinstall'firefox ' ;;
	    *Chromium*) toinstall=$toinstall'chromium ';;
	    *VLC*) toinstall=$toinstall'vlc ';;
	    *Libreoffice*) toinstall=$toinstall'libreoffice libreoffice-langpack-de libreoffice-langpack-en';;
	    *FlashPlayer*) toinstall=$toinstall'flash-plugin ';;
	    *XBMC*) toinstall=$toinstall'xbmc ';;
	    *Yakuake*) toinstall=$toinstall'yakuake ';;
	    *QGIS*) toinstall=$toinstall'qgis '; qgis=true;;
	    *Spatzialite-Fedora-only*) toinstall=$toinstall'libspatialite ';;
	    *Spatzialite-Gui-Fedora-only*) toinstall=$toinstall'spatialite-gui ';;
	    *Microsoft-Fonts*) toinstall=$toinstall'msfonts '; msfont=true;;
			*QT-Dev*) toinstall=$toinstall'qt';;
	    *Java*) toinstall=$toinstall'java ';;
	    *WINE*) toinstall=$toinstall'wine ';;
      esac
      install=$(echo $install | cut -d" " -f2-)
  done
  installpro=false
  installproready=true
}

readyforall() {
    print=""
    if [ $update == true ];
        then
            print=$print$updatetext
    fi
    if [ $installproready == true ];
        then 
            print=$print$backup
    fi
    dialog --backtitle "$version" --yesno "$print" 0 0
    # 0=ja; 1=nein
    antwort=$?
    # Bildschirm löschen
    clear
    # Ausgabe auf die Konsole
    if [ $antwort = 0 ]
        then
            echo "Start Update/Install!"
            ready=true
        else
            echo "Stop program!"
            exit
    fi
}

	# check root Rechte
if [ $(id -u) -ne 0 ]; then
  echo "Skript muss als Root gestartet werden"
  exit
fi
    #echo "Root -> OK"
	# check end root Rechte
	# start Variablen
version="SysUpIn_v0.2.2 by David Baumgartner"
toinstall=""	        # what's to install
system=""	            # distripution
hardware=""	            # Hardware i386/x86_64
pacman=""	            # Paket Manager
update=false	        # Systemupdate
sysupdate=false         # to set system update
installpro=false        # to set the apps to install
ready=false             # ready for update and install
installproready=false   # apps ready for install
qgis=false		        # app qgis install
msfont=false            # check for Fedora
	# end Variablen
	# start get System INFOS
system=`cat /etc/*-release | grep ID=`
system=$(echo $system | cut -d" " -f1)
system=${system#*ID=}
    #echo $system
hardware=`uname -i`
    # end get System INFOS
    # get System Package Manager || I know pacman is the Package Manager of Gentoo but the name is perfekt
case "$system" in
  fedora) pacman="yum";;
  debian) pacman="apt-get";;
  Ubuntu) pacman="apt-get";;
esac
    # end System Package Manager
	# start install dialog and wget for basics
sudo $pacman install dialog wget -y
    # end install dialog and wget
    # start dialog loop
while [  $ready == false ]; do

    todo=`dialog --backtitle "$version" --menu "What do you want?" 0 0 0 \
        "Systemudpate" "" "Select-Apps" "" "ReadyForInstall" "" "Exit" "" 3>&1 1>&2 2>&3`
    antwort=$?
    dialog --clear
    clear
    if [ $antwort = 1 ]
        then
            echo "Stop program!"
            exit
    fi
            # start exec functions
    case "$todo" in
	    Systemudpate) systemupdate ;;
	    Select-Apps) installprofkt ;;
	    ReadyForInstall) readyforall ;;
	    Exit) echo "Stop program!" ; exit ;;
    esac
            # end exec functions
done
    # end dialog loop
    # start exec of user input | what he wants
if [ $ready == true ];
    then
	# start get fedora special stuff
        if [ $pacman = "yum" ];
            then
                        # start get chromium repo 
            if [ -f /etc/yum.repos.d/fedora-chromium-stable.repo ];
                then
                    echo "Chromium repo OK"
                else
                    su -c "wget http://repos.fedorapeople.org/repos/spot/chromium-stable/fedora-chromium-stable.repo -O /etc/yum.repos.d/fedora-chromium-stable.repo"
			# start set fedora 20 special
           	    fedoraversion=`cat /etc/*-release | grep VERSION_ID=`
	            fedoraversion=${fedoraversion#*VERSION_ID=}
	            if [ $fedoraversion == 20 ];
	                then
		                sed -i 's/$releasever/19/g' /etc/yum.repos.d/fedora-chromium-stable.repo
	            fi
                        # end set fedora 20 special
            fi
                        # end get chromium repo
                        # start set MSFonts on Fedora
            if [ $msfont == true ];
                then
                    toinstall=`echo "$toinstall" | sed 's/msfonts/rpm-build cabextract ttmkfdir/g'`
            fi
                        # end set MSFonts on Fedora
                        # start get QGIS Fedora repo
            if [  $qgis == true -a ! -s /etc/yum.repos.d/qgis.repo ];
		        then
		            sudo wget fedora.vitu.ch/QGIS/qgis.repo -P /etc/yum.repos.d/
		            sudo rpm --import http://fedora.vitu.ch/Fedora/RPM-GPG-Key-vitu
		            sudo yum update -y
		        else
		            echo "QGIS repo OK"
	        fi
                        # end get QGIS Fedora repo
                        # start get rpmFusion repo
            if [ -f /etc/yum.repos.d/rpmfusion-nonfree.repo ];
                then
                    echo "Fusion repo OK"
                else
                    sudo yum localinstall -y --nogpgcheck http://download1.rpmfusion.org/free/fedora/rpmfusion-free-release-$(rpm -E %fedora).noarch.rpm
                    sudo yum localinstall -y --nogpgcheck http://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm 
            fi
                        # end get rpmFusion repo
                        # start get adobe repo for flash player
            if [ -f /etc/yum.repos.d/adobe-linux-$hardware.repo ];
                then
                    echo "Adobe repo OK"
                else
                    if [ $hardware = "x86_64" ];
	                    then
	                        sudo yum -y install http://linuxdownload.adobe.com/adobe-release/adobe-release-x86_64-1.0-1.noarch.rpm
	                    else
													sudo yum -y install http://linuxdownload.adobe.com/adobe-release/adobe-release-i386-1.0-1.noarch.rpm
                    fi
                    rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-adobe-linux
            fi
                        # end get adobe repo for flash player
			toinstall=`echo "$toinstall" | sed 's/qt/qt qt-devel qt-creator/g'`
        fi
                # end get fedora special stuff
                # set ubuntu differant app names
        if [ "$system" = "Ubuntu" ];
            then
                toinstall=`echo "$toinstall" | sed 's/flash-plugin/flashplugin-installer/g'`
                toinstall=`echo "$toinstall" | sed 's/java/openjdk-7-jre/g'`
                toinstall=`echo "$toinstall" | sed 's/chromium/chromium-browser/g'`
                toinstall=`echo "$toinstall" | sed 's/qgis/qgis python-qgis qgis-plugin-grass/g'`
                toinstall=`echo "$toinstall" | sed 's/msfonts/ttf-mscorefonts-installer/g'`
								toinstall=`echo "$toinstall" | sed 's/qt/qt5-default qt4-default qttools5-dev-tools qttools5-dev-tools/g'`
                sudo apt-get update -y
        fi
            # end ubuntu differants
        	# start exec update system
        if [ $update == true ];
            then
                case "$system" in
                    fedora) sudo yum update -y;;
                    Ubuntu) sudo apt-get -y upgrade;;
                esac
        fi
            # end exec update system
            # start Fedora QGIS exeption
        if [ $installproready == true -a $pacman == "yum" -a $qgis == true ];
	        then
	            sudo $pacman install qgis qgis-python qgis-mapserver -y --nogpgcheck
	    	fi
            # end Fedora QGIS exeption
	        # start exec app install
        if [ $installproready == true ];
            then
                case "$system" in
                    fedora) sudo $pacman install $toinstall -y;;
                    Ubuntu) sudo $pacman install $toinstall -y;;
                esac
                    # start installing MSFonts
            if [ $pacman == "yum" -a $msfont == true ];
                then
                    wget http://corefonts.sourceforge.net/msttcorefonts-2.5-1.spec
                    rpmbuild -ba msttcorefonts-2.5-1.spec
                    yum install --nogpgcheck /root/rpmbuild/RPMS/noarch/msttcorefonts-2.5-1.noarch.rpm -y
            fi
                    # end installing MSFonts
        fi
	        # end exec app install
fi
